Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: REQUIRED | OPTIONAL | DETAIL: ELEMENT

## javax.ws.rs
Annotation Type Path

    @Target(value={TYPE,METHOD})
    @Retention(value=RUNTIME)
    public @interface Path

Identifies the URI path that a resource class or class method will serve requests for.

Paths are relative. For an annotated class the base URI is the application path, see `ApplicationPath`. For an annotated method the base URI is the effective URI of the containing class. For the purposes of absolutizing a path against the base URI , a leading '/' in a path is ignored and base URIs are treated as if they ended in '/'. E.g.:

    @Path("widgets")
    public class WidgetsResource {
      @GET
      String getList() {...}

      @GET @Path("{id}")
      String getWidget(@PathParam("id") String id) {...}
    }

In the above, if the application path is `catalogue` and the application is deployed at `http://example.com/`, then `GET` requests for `http://example.com/catalogue/widgets` will be handled by the `getList` method while requests for `http://example.com/catalogue/widgets/nnn` (where `nnn` is some value) will be handled by the `getWidget` method. The same would apply if the value of either `@Path` annotation started with '/'.

Classes and methods may also be annotated with `Consumes` and `Produces` to filter the requests they will receive.

See Also:
  `Consumes`, `Produces`, `PathParam`

Required Element Summary
`java.lang.String` | `value` Defines a URI template for the resource class or method, must not include matrix parameters.

Element Detail

### value

    public abstract java.lang.String value

  Defines a URI template for the resource class or method, must not include matrix parameters.

  Embedded template parameters are allowed and are of the form:

       param = "{" *WSP name *WSP [ ":" *WSP regex *WSP ] "}"
       name = (ALPHA / DIGIT / "_")*(ALPHA / DIGIT / "." / "_" / "-" ) ; \w[\w\.-]*
       regex = *( nonbrace / "{" *nonbrace "}" ) ; where nonbrace is any char other than "{" and "}"

  See RFC 5234 for a description of the syntax used above and the expansions of `WSP`, `ALPHA` and `DIGIT`. In the above `name` is the template parameter name and the optional `regex` specifies the contents of the capturing group for the parameter. If `regex` is not supplied then a default value of `[^/]+` which terminates at a path segment boundary, is used. Matching of request URIs to URI templates is performed against encoded path values and implementations will not escape literal characters in regex automatically, therefore any literals in `regex` should be escaped by the author according to the rules of RFC 3986 section 3.3. Caution is recommended in the use of `regex`, incorrect use can lead to a template parameter matching unexpected URI paths. See Pattern for further information on the syntax of regular expressions. Values of template parameters may be extracted using `PathParam`.

  The literal part of the supplied value (those characters that are not part of a template parameter) is automatically percent encoded to conform to the `path` production of RFC 3986 section 3.3. Note that percent encoded values are allowed in the literal part of the value, an implementation will recognize such values and will not double encode the '%' character.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: REQUIRED | OPTIONAL | DETAIL: ELEMENT

Copyright © 2009 Sun Microsystems, Inc. All Rights Reserved.